package com.dsic.gj_erp.bean.zyjh;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.dsic.gj_erp.bean.jcsj.DmBchxylp;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

@Getter
@Setter
@TableName("dm_yl_info")
public class DmYlInfo {
    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    private String 余料编号;//余料编号,套料图中存在编号时产生

    private String 规格;//规格

    private BigDecimal 板厚;

    private BigDecimal 板宽;

    private BigDecimal 板长;

    private String 炉批号;

    private String 重量;

    private String 数量="1";

    private String 垛位;

    private String 层数;

    private String 来源船号;//来源船号

    private String 来源批量;//来源批量

    private String 来源图纸;//来源图纸

    private String 物品型号;

    private String 物品规格;

    private String 切割日期;

    private String 使用船号;//使用船号

    private String 使用批量;//使用批量

    private String 使用分段;//使用分段

    private String 使用图纸;//使用图纸

    private String 使用日期;//同打印日期

    private int 使用状态;//0:未使用;1:已使用;2:已打印;3:已切割

    public boolean 指定余料编号的上料匹配(String 余料编号){
        return StrUtil.isNotEmpty(this.余料编号) &&this.余料编号.equals(余料编号);
    }

    public boolean 上料匹配(DmYdjh ydjh){
        if (使用状态>0){
            return false;
        }
        if (ydjh.getWpxh()==null||ydjh.getWpgg()==null){
            return false;
        }

        String[] split = ydjh.getWpgg().split("\\*");
        if (split.length<3){
            return false;
        }
        //必须保证材质相同,厚度相同,宽和长要小于余料的宽和长才能使用
        return ydjh.getWpxh().equals(物品型号)
                &&new BigDecimal(split[0]).compareTo(板厚)==0
                &&new BigDecimal(split[1]).compareTo(板宽)<=0
                &&new BigDecimal(split[1]).compareTo(板长)<=0;
    }

    public void 修正上料信息(DmYdjh ydjh){
        使用船号=ydjh.getDcCh();
        使用批量=ydjh.getDcPl();
        使用分段=ydjh.getDcFd();
        使用图纸=ydjh.getTzbh();
        使用状态=UseStatus.已使用.ordinal();
    }

    public static DmYlInfo of(DmBchxylp bchxylp, DmYdjh ydjh){
        DmYlInfo dmYlInfo = new DmYlInfo();
        dmYlInfo.余料编号=bchxylp.getYlbh();
        dmYlInfo.规格=bchxylp.getYlgg();

        if (dmYlInfo.规格!=null){
            String[] split = dmYlInfo.规格.split("\\*");
            if (split.length>=3){
                dmYlInfo.板厚=new BigDecimal(split[0]);
                dmYlInfo.板宽=new BigDecimal(split[1]);
                dmYlInfo.板长=new BigDecimal(split[2]);
            }
        }

        dmYlInfo.炉批号= ydjh.getSllph();
        if (ydjh.getBcylzl()!=null){
            dmYlInfo.重量=ydjh.getBcylzl().toString();
        }
        dmYlInfo.来源船号=ydjh.getDcCh();
        dmYlInfo.来源批量=ydjh.getDcPl();
        dmYlInfo.来源图纸=ydjh.getTzbh();
        dmYlInfo.物品型号=bchxylp.getWpxh();
        dmYlInfo.物品规格=ydjh.getWpgg();
        dmYlInfo.切割日期= DateUtil.date().toString("yyyy/MM/dd");
        dmYlInfo.使用状态=UseStatus.未使用.ordinal();
        return dmYlInfo;
    }

    public enum UseStatus{
        未使用,已使用,已打印,已切割
    }
}
